-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Gantt - Strip Lines
This demo illustrates how to use strip lines to highlight different times in the DevExtreme JavaScript Gantt component. The JavaScript Gantt stores strip lines in its stripLines collection. You can specify a title (title) and appearance settings (CssClass) for each strip line.
Use the start property to specify an individual strip line or combine it with the end property to specify a time interval.
Backend API
$(() => {
$('#gantt').dxGantt({
stripLines: [{
title: 'Start',
start: tasks[0].start,
}, {
title: 'Final Phase',
start: tasks[tasks.length - 3].start,
end: tasks[tasks.length - 1].end,
}, {
title: 'Current Time',
start: currentDate,
cssClass: 'current-time',
}],
tasks: {
dataSource: tasks,
},
editing: {
enabled: false,
},
validation: {
autoUpdateParentTasks: true,
},
columns: [{
dataField: 'title',
caption: 'Task',
width: 300,
}],
taskListWidth: 300,
taskTitlePosition: 'none',
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<script src="https://cdn3.devexpress.com/jslib/26.1.4/js/dx-gantt.min.js"></script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx-gantt.min.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="gantt"> </div>
</div>
</body>
</html>
#gantt {
height: 700px;
}
#gantt .current-time {
border-left: 1px solid red;
}
const currentDate = new Date(Date.now());
const month = currentDate.getMonth();
const year = currentDate.getFullYear();
const tasks = [{
id: 1,
parentId: 0,
title: 'Johnson Residence Construction Project',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
}, {
id: 2,
parentId: 1,
title: 'Planning and Pre-Construction Phase',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
}, {
id: 3,
parentId: 2,
title: 'Architectural Design and Site Planning',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 15),
progress: 0,
}, {
id: 4,
parentId: 2,
title: 'Engineering and Final Blueprint',
start: new Date(year, month - 1, 8),
end: new Date(year, month - 1, 15),
progress: 0,
}, {
id: 5,
parentId: 2,
title: 'City Permits and Contracts',
start: new Date(year, month - 1, 15),
end: new Date(year, month - 1, 18),
progress: 0,
}, {
id: 6,
parentId: 1,
title: 'Construction Phase',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 18),
progress: 0,
}, {
id: 7,
parentId: 6,
title: 'Grading and Excavation',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 22),
progress: 0,
}, {
id: 8,
parentId: 6,
title: 'Demolition and Removal',
start: new Date(year, month - 1, 19),
end: new Date(year, month - 1, 23),
progress: 0,
}, {
id: 9,
parentId: 6,
title: 'Foundation and Concrete ',
start: new Date(year, month - 1, 22),
end: new Date(year, month - 1, 28),
progress: 0,
}, {
id: 10,
parentId: 6,
title: 'Rough Framing and Carpentery',
start: new Date(year, month - 1, 25),
end: new Date(year, month, 5),
progress: 0,
}, {
id: 11,
parentId: 6,
title: 'Inspection (Structure)',
start: new Date(year, month, 5),
end: new Date(year, month, 5),
progress: 0,
}, {
id: 12,
parentId: 6,
title: 'Electrical Rough-in',
start: new Date(year, month, 6),
end: new Date(year, month, 19),
progress: 0,
}, {
id: 13,
parentId: 6,
title: 'Plumbing Rough-in',
start: new Date(year, month, 19),
end: new Date(year, month, 19),
progress: 0,
}, {
id: 14,
parentId: 6,
title: 'Heating and A/C',
start: new Date(year, month, 19),
end: new Date(year, month, 26),
progress: 0,
}, {
id: 15,
parentId: 6,
title: 'Drywall',
start: new Date(year, month, 25),
end: new Date(year, month + 1, 10),
progress: 0,
}, {
id: 16,
parentId: 6,
title: 'Painting (Exterior)',
start: new Date(year, month + 1, 7),
end: new Date(year, month + 1, 21),
progress: 0,
}, {
id: 17,
parentId: 6,
title: 'Interior Carpentery (Interior)',
start: new Date(year, month + 1, 17),
end: new Date(year, month + 1, 28),
progress: 0,
}, {
id: 18,
parentId: 6,
title: 'Flooring and Interior Paint',
start: new Date(year, month + 1, 26),
end: new Date(year, month + 2, 9),
progress: 0,
}, {
id: 19,
parentId: 1,
title: 'Final Phase',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 9),
progress: 0,
}, {
id: 20,
parentId: 19,
title: 'Review-Punch List',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 23),
progress: 0,
}, {
id: 21,
parentId: 19,
title: 'Final Inspection',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 24),
progress: 0,
}, {
id: 22,
parentId: 19,
title: 'Final Paperwork and Documents',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 28),
progress: 0,
}];

Backend API
<template>
<DxGantt
:task-list-width="300"
:height="700"
task-title-position="none"
>
<DxStripLine
:start="tasks[0].start"
title="Start"
/>
<DxStripLine
:start="tasks[tasks.length - 3].start"
:end="tasks[tasks.length - 1].end"
title="Final Phase"
/>
<DxStripLine
:start="currentTime"
title="Current Time"
css-class="current-time"
/>
<DxValidation :auto-update-parent-tasks="true"/>
<DxTasks :data-source="tasks"/>
<DxColumn
:width="300"
data-field="title"
caption="Task"
/>
</DxGantt>
</template>
<script setup lang="ts">
import {
DxGantt,
DxTasks,
DxColumn,
DxValidation,
DxStripLine,
} from 'devextreme-vue/gantt';
import {
tasks,
} from './data.ts';
const currentTime = new Date();
</script>
<style>
.dx-gantt .dx-gantt-tm.current-time {
border-left: 1px solid red;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
const currentDate = new Date(Date.now());
const month = currentDate.getMonth();
const year = currentDate.getFullYear();
export const tasks = [{
id: 1,
parentId: 0,
title: 'Johnson Residence Construction Project',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
}, {
id: 2,
parentId: 1,
title: 'Planning and Pre-Construction Phase',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
}, {
id: 3,
parentId: 2,
title: 'Architectural Design and Site Planning',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 15),
progress: 0,
}, {
id: 4,
parentId: 2,
title: 'Engineering and Final Blueprint',
start: new Date(year, month - 1, 8),
end: new Date(year, month - 1, 15),
progress: 0,
}, {
id: 5,
parentId: 2,
title: 'City Permits and Contracts',
start: new Date(year, month - 1, 15),
end: new Date(year, month - 1, 18),
progress: 0,
}, {
id: 6,
parentId: 1,
title: 'Construction Phase',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 18),
progress: 0,
}, {
id: 7,
parentId: 6,
title: 'Grading and Excavation',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 22),
progress: 0,
}, {
id: 8,
parentId: 6,
title: 'Demolition and Removal',
start: new Date(year, month - 1, 19),
end: new Date(year, month - 1, 23),
progress: 0,
}, {
id: 9,
parentId: 6,
title: 'Foundation and Concrete ',
start: new Date(year, month - 1, 22),
end: new Date(year, month - 1, 28),
progress: 0,
}, {
id: 10,
parentId: 6,
title: 'Rough Framing and Carpentery',
start: new Date(year, month - 1, 25),
end: new Date(year, month, 5),
progress: 0,
}, {
id: 11,
parentId: 6,
title: 'Inspection (Structure)',
start: new Date(year, month, 5),
end: new Date(year, month, 5),
progress: 0,
}, {
id: 12,
parentId: 6,
title: 'Electrical Rough-in',
start: new Date(year, month, 6),
end: new Date(year, month, 19),
progress: 0,
}, {
id: 13,
parentId: 6,
title: 'Plumbing Rough-in',
start: new Date(year, month, 19),
end: new Date(year, month, 19),
progress: 0,
}, {
id: 14,
parentId: 6,
title: 'Heating and A/C',
start: new Date(year, month, 19),
end: new Date(year, month, 26),
progress: 0,
}, {
id: 15,
parentId: 6,
title: 'Drywall',
start: new Date(year, month, 25),
end: new Date(year, month + 1, 10),
progress: 0,
}, {
id: 16,
parentId: 6,
title: 'Painting (Exterior)',
start: new Date(year, month + 1, 7),
end: new Date(year, month + 1, 21),
progress: 0,
}, {
id: 17,
parentId: 6,
title: 'Interior Carpentery (Interior)',
start: new Date(year, month + 1, 17),
end: new Date(year, month + 1, 28),
progress: 0,
}, {
id: 18,
parentId: 6,
title: 'Flooring and Interior Paint',
start: new Date(year, month + 1, 26),
end: new Date(year, month + 2, 9),
progress: 0,
}, {
id: 19,
parentId: 1,
title: 'Final Phase',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 9),
progress: 0,
}, {
id: 20,
parentId: 19,
title: 'Review-Punch List',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 23),
progress: 0,
}, {
id: 21,
parentId: 19,
title: 'Final Inspection',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 24),
progress: 0,
}, {
id: 22,
parentId: 19,
title: 'Final Paperwork and Documents',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 28),
progress: 0,
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx-gantt.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

Backend API
<dx-gantt taskListWidth="300" height="700" taskTitlePosition="none">
<dxi-strip-line [start]="tasks[0].start" title="Start"> </dxi-strip-line>
<dxi-strip-line
[start]="tasks[tasks.length - 3].start"
[end]="tasks[tasks.length - 1].end"
title="Final Phase"
>
</dxi-strip-line>
<dxi-strip-line
[start]="currentTime"
title="Current Time"
cssClass="current-time"
>
</dxi-strip-line>
<dxo-validation [autoUpdateParentTasks]="true"></dxo-validation>
<dxo-tasks [dataSource]="tasks"></dxo-tasks>
<dxi-column dataField="title" caption="Task" [width]="300"></dxi-column>
</dx-gantt>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxGanttModule } from 'devextreme-angular';
import { Service, Task } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
preserveWhitespaces: true,
})
export class AppComponent {
tasks: Task[];
currentTime: Date;
constructor(service: Service) {
this.tasks = service.getTasks();
this.currentTime = new Date();
}
}
@NgModule({
imports: [
BrowserModule,
DxGanttModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .dx-gantt .dx-gantt-tm.current-time {
border-left: 1px solid red;
}
import { Injectable } from '@angular/core';
export class Task {
id: number;
parentId: number;
title: string;
start: Date;
end: Date;
progress: number;
}
const currentDate: Date = new Date(Date.now());
const month: number = currentDate.getMonth();
const year: number = currentDate.getFullYear();
const tasks: Task[] = [{
id: 1,
parentId: 0,
title: 'Johnson Residence Construction Project',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
}, {
id: 2,
parentId: 1,
title: 'Planning and Pre-Construction Phase',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
}, {
id: 3,
parentId: 2,
title: 'Architectural Design and Site Planning',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 15),
progress: 0,
}, {
id: 4,
parentId: 2,
title: 'Engineering and Final Blueprint',
start: new Date(year, month - 1, 8),
end: new Date(year, month - 1, 15),
progress: 0,
}, {
id: 5,
parentId: 2,
title: 'City Permits and Contracts',
start: new Date(year, month - 1, 15),
end: new Date(year, month - 1, 18),
progress: 0,
}, {
id: 6,
parentId: 1,
title: 'Construction Phase',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 18),
progress: 0,
}, {
id: 7,
parentId: 6,
title: 'Grading and Excavation',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 22),
progress: 0,
}, {
id: 8,
parentId: 6,
title: 'Demolition and Removal',
start: new Date(year, month - 1, 19),
end: new Date(year, month - 1, 23),
progress: 0,
}, {
id: 9,
parentId: 6,
title: 'Foundation and Concrete ',
start: new Date(year, month - 1, 22),
end: new Date(year, month - 1, 28),
progress: 0,
}, {
id: 10,
parentId: 6,
title: 'Rough Framing and Carpentery',
start: new Date(year, month - 1, 25),
end: new Date(year, month, 5),
progress: 0,
}, {
id: 11,
parentId: 6,
title: 'Inspection (Structure)',
start: new Date(year, month, 5),
end: new Date(year, month, 5),
progress: 0,
}, {
id: 12,
parentId: 6,
title: 'Electrical Rough-in',
start: new Date(year, month, 6),
end: new Date(year, month, 19),
progress: 0,
}, {
id: 13,
parentId: 6,
title: 'Plumbing Rough-in',
start: new Date(year, month, 19),
end: new Date(year, month, 19),
progress: 0,
}, {
id: 14,
parentId: 6,
title: 'Heating and A/C',
start: new Date(year, month, 19),
end: new Date(year, month, 26),
progress: 0,
}, {
id: 15,
parentId: 6,
title: 'Drywall',
start: new Date(year, month, 25),
end: new Date(year, month + 1, 10),
progress: 0,
}, {
id: 16,
parentId: 6,
title: 'Painting (Exterior)',
start: new Date(year, month + 1, 7),
end: new Date(year, month + 1, 21),
progress: 0,
}, {
id: 17,
parentId: 6,
title: 'Interior Carpentery (Interior)',
start: new Date(year, month + 1, 17),
end: new Date(year, month + 1, 28),
progress: 0,
}, {
id: 18,
parentId: 6,
title: 'Flooring and Interior Paint',
start: new Date(year, month + 1, 26),
end: new Date(year, month + 2, 9),
progress: 0,
}, {
id: 19,
parentId: 1,
title: 'Final Phase',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 9),
progress: 0,
}, {
id: 20,
parentId: 19,
title: 'Review-Punch List',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 23),
progress: 0,
}, {
id: 21,
parentId: 19,
title: 'Final Inspection',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 24),
progress: 0,
}, {
id: 22,
parentId: 19,
title: 'Final Paperwork and Documents',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 28),
progress: 0,
}];
@Injectable()
export class Service {
getTasks(): Task[] {
return tasks;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.24/package.json',
'npm:devexpress-gantt@4.1.64/package.json',
],
};
System.config(window.config);
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "17.3.12"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.4.5"
},
"zone.js": {
"version": "0.14.10"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx-gantt.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.14.10/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

Backend API
import React from 'react';
import Gantt, {
Tasks, Column, Validation, StripLine,
} from 'devextreme-react/gantt';
import { tasks, currentDate } from './data.ts';
function App() {
return (
<Gantt
taskListWidth={300}
height={700}
taskTitlePosition="none">
<StripLine start={tasks[0].start} title="Start" />
<StripLine start={tasks[tasks.length - 3].start} end={tasks[tasks.length - 1].end} title="Final Phase" />
<StripLine start={currentDate} title="Current Time" cssClass="current-time" />
<Validation autoUpdateParentTasks />
<Tasks dataSource={tasks} />
<Column dataField="title" caption="Task" width={300} />
</Gantt>
);
}
export default App;
import React from 'react';
import Gantt, {
Tasks, Column, Validation, StripLine,
} from 'devextreme-react/gantt';
import { tasks, currentDate } from './data.js';
function App() {
return (
<Gantt
taskListWidth={300}
height={700}
taskTitlePosition="none"
>
<StripLine
start={tasks[0].start}
title="Start"
/>
<StripLine
start={tasks[tasks.length - 3].start}
end={tasks[tasks.length - 1].end}
title="Final Phase"
/>
<StripLine
start={currentDate}
title="Current Time"
cssClass="current-time"
/>
<Validation autoUpdateParentTasks />
<Tasks dataSource={tasks} />
<Column
dataField="title"
caption="Task"
width={300}
/>
</Gantt>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const currentDate = new Date(Date.now());
const month = currentDate.getMonth();
const year = currentDate.getFullYear();
export const tasks = [{
id: 1,
parentId: 0,
title: 'Johnson Residence Construction Project',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
}, {
id: 2,
parentId: 1,
title: 'Planning and Pre-Construction Phase',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
}, {
id: 3,
parentId: 2,
title: 'Architectural Design and Site Planning',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 15),
progress: 0,
}, {
id: 4,
parentId: 2,
title: 'Engineering and Final Blueprint',
start: new Date(year, month - 1, 8),
end: new Date(year, month - 1, 15),
progress: 0,
}, {
id: 5,
parentId: 2,
title: 'City Permits and Contracts',
start: new Date(year, month - 1, 15),
end: new Date(year, month - 1, 18),
progress: 0,
}, {
id: 6,
parentId: 1,
title: 'Construction Phase',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 18),
progress: 0,
}, {
id: 7,
parentId: 6,
title: 'Grading and Excavation',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 22),
progress: 0,
}, {
id: 8,
parentId: 6,
title: 'Demolition and Removal',
start: new Date(year, month - 1, 19),
end: new Date(year, month - 1, 23),
progress: 0,
}, {
id: 9,
parentId: 6,
title: 'Foundation and Concrete ',
start: new Date(year, month - 1, 22),
end: new Date(year, month - 1, 28),
progress: 0,
}, {
id: 10,
parentId: 6,
title: 'Rough Framing and Carpentery',
start: new Date(year, month - 1, 25),
end: new Date(year, month, 5),
progress: 0,
}, {
id: 11,
parentId: 6,
title: 'Inspection (Structure)',
start: new Date(year, month, 5),
end: new Date(year, month, 5),
progress: 0,
}, {
id: 12,
parentId: 6,
title: 'Electrical Rough-in',
start: new Date(year, month, 6),
end: new Date(year, month, 19),
progress: 0,
}, {
id: 13,
parentId: 6,
title: 'Plumbing Rough-in',
start: new Date(year, month, 19),
end: new Date(year, month, 19),
progress: 0,
}, {
id: 14,
parentId: 6,
title: 'Heating and A/C',
start: new Date(year, month, 19),
end: new Date(year, month, 26),
progress: 0,
}, {
id: 15,
parentId: 6,
title: 'Drywall',
start: new Date(year, month, 25),
end: new Date(year, month + 1, 10),
progress: 0,
}, {
id: 16,
parentId: 6,
title: 'Painting (Exterior)',
start: new Date(year, month + 1, 7),
end: new Date(year, month + 1, 21),
progress: 0,
}, {
id: 17,
parentId: 6,
title: 'Interior Carpentery (Interior)',
start: new Date(year, month + 1, 17),
end: new Date(year, month + 1, 28),
progress: 0,
}, {
id: 18,
parentId: 6,
title: 'Flooring and Interior Paint',
start: new Date(year, month + 1, 26),
end: new Date(year, month + 2, 9),
progress: 0,
}, {
id: 19,
parentId: 1,
title: 'Final Phase',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 9),
progress: 0,
}, {
id: 20,
parentId: 19,
title: 'Review-Punch List',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 23),
progress: 0,
}, {
id: 21,
parentId: 19,
title: 'Final Inspection',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 24),
progress: 0,
}, {
id: 22,
parentId: 19,
title: 'Final Paperwork and Documents',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 28),
progress: 0,
}];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const currentDate = new Date(Date.now());
const month = currentDate.getMonth();
const year = currentDate.getFullYear();
export const tasks = [
{
id: 1,
parentId: 0,
title: 'Johnson Residence Construction Project',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
},
{
id: 2,
parentId: 1,
title: 'Planning and Pre-Construction Phase',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
},
{
id: 3,
parentId: 2,
title: 'Architectural Design and Site Planning',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 15),
progress: 0,
},
{
id: 4,
parentId: 2,
title: 'Engineering and Final Blueprint',
start: new Date(year, month - 1, 8),
end: new Date(year, month - 1, 15),
progress: 0,
},
{
id: 5,
parentId: 2,
title: 'City Permits and Contracts',
start: new Date(year, month - 1, 15),
end: new Date(year, month - 1, 18),
progress: 0,
},
{
id: 6,
parentId: 1,
title: 'Construction Phase',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 18),
progress: 0,
},
{
id: 7,
parentId: 6,
title: 'Grading and Excavation',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 22),
progress: 0,
},
{
id: 8,
parentId: 6,
title: 'Demolition and Removal',
start: new Date(year, month - 1, 19),
end: new Date(year, month - 1, 23),
progress: 0,
},
{
id: 9,
parentId: 6,
title: 'Foundation and Concrete ',
start: new Date(year, month - 1, 22),
end: new Date(year, month - 1, 28),
progress: 0,
},
{
id: 10,
parentId: 6,
title: 'Rough Framing and Carpentery',
start: new Date(year, month - 1, 25),
end: new Date(year, month, 5),
progress: 0,
},
{
id: 11,
parentId: 6,
title: 'Inspection (Structure)',
start: new Date(year, month, 5),
end: new Date(year, month, 5),
progress: 0,
},
{
id: 12,
parentId: 6,
title: 'Electrical Rough-in',
start: new Date(year, month, 6),
end: new Date(year, month, 19),
progress: 0,
},
{
id: 13,
parentId: 6,
title: 'Plumbing Rough-in',
start: new Date(year, month, 19),
end: new Date(year, month, 19),
progress: 0,
},
{
id: 14,
parentId: 6,
title: 'Heating and A/C',
start: new Date(year, month, 19),
end: new Date(year, month, 26),
progress: 0,
},
{
id: 15,
parentId: 6,
title: 'Drywall',
start: new Date(year, month, 25),
end: new Date(year, month + 1, 10),
progress: 0,
},
{
id: 16,
parentId: 6,
title: 'Painting (Exterior)',
start: new Date(year, month + 1, 7),
end: new Date(year, month + 1, 21),
progress: 0,
},
{
id: 17,
parentId: 6,
title: 'Interior Carpentery (Interior)',
start: new Date(year, month + 1, 17),
end: new Date(year, month + 1, 28),
progress: 0,
},
{
id: 18,
parentId: 6,
title: 'Flooring and Interior Paint',
start: new Date(year, month + 1, 26),
end: new Date(year, month + 2, 9),
progress: 0,
},
{
id: 19,
parentId: 1,
title: 'Final Phase',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 9),
progress: 0,
},
{
id: 20,
parentId: 19,
title: 'Review-Punch List',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 23),
progress: 0,
},
{
id: 21,
parentId: 19,
title: 'Final Inspection',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 24),
progress: 0,
},
{
id: 22,
parentId: 19,
title: 'Final Paperwork and Documents',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 28),
progress: 0,
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx-gantt.min.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.dx-gantt .dx-gantt-tm.current-time {
border-left: 1px solid red;
}